TUGAS1PPW/urls.py
from django.conf.urls import url, include
from django.contrib import admin
from django.views.generic.base import RedirectView
import updatestatus.urls as updatestatus
import add_friend.urls as add_friend
import profil.urls as profil
import home.urls as home


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^update-status/', include(updatestatus, namespace='update-status')),
    url(r'^add-friend/', include(add_friend,namespace='add-friend')),
    url(r'^home/', include(home,namespace='home')),
    url(r'^profil/', include(profil,namespace='profil')),
    url(r'^$', RedirectView.as_view(url='/home/',permanent=True), name='redirect_landing_page'),

]

add_friend/urls.py
from django.conf.urls import url
from .views import index, add_friend

urlpatterns = [
    url(r'^$', index, name='index'),
    url(r'^add_friend', add_friend, name='add_friend'),
]

home/urls.py
from django.conf.urls import url
from .views import index

urlpatterns = [
    url(r'^$', index, name='index'),
]

profil/urls.py
from django.conf.urls import url
from .views import index

urlpatterns = [
    url(r'^$', index, name='index'),
]

updatestatus/urls.py
from django.conf.urls import url
from .views import index, add_todo, delete_status

urlpatterns = [
	url(r'^$', index, name='index'),
	url(r'^add_todo', add_todo, name='add_todo'),
	url(r'^delete_status/(?P<id_status>[0-9]+)', delete_status, name = 'delete_status'),
 ]

add_friend/models.py
from django.db import models

class Message(models.Model):
	name = models.CharField(max_length=27)
	heroku_url = models.CharField(max_length=200)
	created_date = models.DateTimeField(auto_now_add=True)

home/models.py
from django.db import models

# Create your models here.

profil/models.py
from django.db import models

# Create your models here.

class DataProfil(models.Model):
	name = models.CharField(max_length=250)
	Birthday = models.CharField(max_length=20)
	Gender = models.CharField(max_length=200)
	expertise = models.TextField(max_length=200)
	Description = models.CharField(max_length=200)
	Email = models.CharField(max_length=200)

updatestatus/models.py
from django.db import models

class Todo(models.Model):
	description=models.TextField()
	created_date=models.DateTimeField(auto_now_add=True)

add_friend/forms.py
from django import forms

class Message_Form(forms.Form):
	error_messages = {
		'required': 'Tolong isi input ini',
		'invalid': 'Isi input dengan email',
	}
	attrs = {
		'class': 'form-control'
	}

	name = forms.CharField(label='Nama', required=True, max_length=27, widget=forms.TextInput(attrs=attrs))
	heroku_url = forms.CharField(label='Heroku URL', required=True, widget=forms.URLInput(attrs=attrs))

updatestatus/forms.py
from django import forms

class Todo_Form(forms.Form):
	error_message = {
		'required': 'Tolong isi update status ini',
	}

	description_attrs = {
		'type': 'text',
		'cols': 100,
		'rows': 4,
		'class': 'todo-form-textarea'
	}

	description = forms.CharField(label='',required=True, widget=forms.Textarea(attrs=description_attrs))

add_friend/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from .forms import Message_Form
from .models import Message


response = {'author': "Hauri Silmi"} #TODO Implement yourname
def index(request):
	html = 'add_friend/add_friend.html'
	response['message_form'] = Message_Form
	# if (Message.objects.count() == 0):
	data = Message.objects.all()
	response['data'] = data
	return render(request, html, response)
	
def add_friend(request):
	form = Message_Form(request.POST or None)
	if(request.method == 'POST' and form.is_valid()):
		response['name'] = request.POST['name'] 
		response['heroku_url'] = request.POST['heroku_url'] 
		data = Message(name=response['name'], heroku_url=response['heroku_url'])
		data.save()
		return HttpResponseRedirect('/add-friend/')
	else:
		return HttpResponseRedirect('/add-friend/')

home/views.py
from django.shortcuts import render 
from add_friend.models import Message
from updatestatus.models import Todo
from profil.models import DataProfil
from datetime import datetime, date
# Create your views here.
response = {}
def index(request):
    profile_name = 'Hepzibah Smith' #TODO implement your name here
    birth_date = date(1998,1,1) #TODO implement your birthday
    birthdate = birth_date.strftime('%d %B %Y')
    gender = 'Female' #TODO implement your gender
    email = 'hello@smith.com' #TODO implement your email
    desc_profile = "Antique expert. Experience as marketer for 10 years"
    #TODO implement your expertise minimal 3
    expert = ["Marketing", "Public Speaking", "Collector"]
    response['author']="Js"
    html = 'home/statistik.html'
    if( DataProfil.objects.all().count() == 0  ): 
        profil = DataProfil(name = profile_name, Birthday = birthdate, Gender= gender, Email = email, Description=desc_profile, expertise=expert)
        profil.save();
    nama = DataProfil.objects.get( pk=1 )
    response['name'] = nama.name
    response['friends'] = Message.objects.all().count()
    response['post'] = Todo.objects.all().count()
    if(Todo.objects.all().count() == 0):
       response['description'] = "No Post" 
    else:
        last = Todo.objects.all()[Todo.objects.all().count() - 1]
        response['description'] = last.description
        response['date'] = last.created_date

    return render(request, html, response)

profil/views.py
from django.shortcuts import render
from datetime import datetime, date
from .models import DataProfil

# Create your views here.
profile_name = 'Hepzibah Smith' #TODO implement your name here
birth_date = date(1998,1,1) #TODO implement your birthday
birthdate = birth_date.strftime('%d %B %Y')
gender = 'Female' #TODO implement your gender
email = 'hello@smith.com' #TODO implement your email
desc_profile = "Antique expert. Experience as marketer for 10 years"
#TODO implement your expertise minimal 3
expert = ["Marketing", "Public Speaking", "Collector"]

def index(request):
	if(DataProfil.objects.count()==0):
		profil = DataProfil(name = profile_name, Birthday = birthdate, Gender= gender, Email = email, Description=desc_profile, expertise=expert)
		profil.save();
	profil = DataProfil.objects.all()[0]
	expertise = [ s[1:-1] for s in profil.expertise[1:-1].split(", ") ]
	response = {'name' : profil.name, 'Birthday' : profil.Birthday, 'Gender': profil.Gender, 'expertise':expertise, 'Description' : profil.Description, 'Email': profil.Email}
	html = 'profil.html'
	return render(request, html, response)	

updatestatus/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from .forms import Todo_Form
from .models import Todo
from profil.views import *
from profil.models import DataProfil

# Create your views here.
response={}

def index(request):
    todo = Todo.objects.order_by('-id')
    response['todo'] = todo
    html = 'updatestatus/update_status.html'
    response['todo_form'] = Todo_Form
    response['name'] = profile_name
    if(DataProfil.objects.count()==0):
        profil = DataProfil(name = profile_name, Birthday = birthdate, Gender= gender, Email = email, Description=desc_profile, expertise=expert)
        profil.save();
    nama = DataProfil.objects.get(pk=1)
    response['author'] = nama.name
    return render(request, html, response)


def add_todo(request):
    form = Todo_Form(request.POST or None)
    if(request.method == 'POST' and form.is_valid()):
        response['description'] = request.POST['description']
        todo = Todo(description=response['description'])
        todo.save()
        return HttpResponseRedirect('/update-status/')
    else:
        return HttpResponseRedirect('/update-status/')

def delete_status(request, id_status):
    status = Todo.objects.get(pk = id_status)
    status.delete()
    return HttpResponseRedirect('/update-status/')

add_friend/templates/add_friend/add_friend.html
{% extends "add_friend/layout/base.html" %}

{% block content %}

<hr/>
<section name="form">
	<h2 style="font-family:bebas neue">ADD FRIEND</h2>
		<form id="form" method="POST" action="{% url 'add-friend:add_friend' %}">
			{% csrf_token %}
			{{ message_form }} 
			<br>
			<button type="submit" class="btn btn-default">Add</button>
		</form>
</section>
<hr/>

{%include "add_friend/table.html" %}

{% endblock %}

add_friend/templates/add_friend/header.html
<nav class="navbar navbar-default  navbar-expand-lg navbar-light bg-light">
    <div class="container-fullwidth">
    <div class="navbar-header ">
        <a class="navbar-brand" href="#">Ling In</a>
        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
    </div>
    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1" >
      <ul class="nav navbar-nav" >    
          <li><a class="link active" href="{% url 'update-status:index' %}">Status <i class="fa fa-star" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'profil:index' %}">Profile <i class="fa fa-user" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'add-friend:index' %}">Friends <i class="fa fa-users" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'home:index' %}">Stats <i class="fa fa-signal" aria-hidden="true"></i></a></li>       
      </ul>
    </div>
  </div>
</nav>

add_friend/templates/add_friend/layout/base.html
{% load static %}
{% load staticfiles %}

<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="description" content="Add Friend">
	<meta name="author" content="{{author}}">
	<!-- bootstrap csss -->
	<link href="//netdna.bootstrapcdn.com/bootstrap/3.1.1/css/bootstrap.min.css" rel="stylesheet"> 
	<link rel="stylesheet" type="text/css" href="{% static 'css/add_friend.css' %}" />
 	
	<title> 
        {% block title %} Add Friend By {{author}}{% endblock %}
	</title>
	<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">
	<link rel="stylesheet" type="text/css" href="{% static 'css/add_friend.css' %}">
</head>

<body>
<header>
		{% include "add_friend/header.html" %}
</header>
	<content>
		<div class="container">
			{% block content %}
				<!-- content goes here -->
			{% endblock %}
		</div>
	</content>
	<footer style="text-align: center"><p>&copy; Made with Love</p></footer>
	<!-- Jquery n Bootstrap Script -->
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
	<script type="application/javascript" src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>
	</body>
</html>

add_friend/templates/add_friend/table.html
<h3 style="font-family:bebas neue">
	List Friend
</h3>
<div class="table-responsive">
	<table class="table">
		<tbody>
			{%if data%}
				{% for i in data %}
				<tr class="info">			
					<td> {{i.name}} </td>
					<td><a href= {{i.heroku_url}}> {{i.heroku_url}} </a></td>
					<td> Added {{i.created_date}} </td>
				</tr>             
				{% endfor %}
			{%else%}
			<div class="alert alert-danger text-center">
                <strong>Oops!</strong> Tidak ada data teman.
            </div>
            {% endif %}
		</tbody>	
	</table>
</div>

home/templates/home/header.html
<nav class="navbar navbar-default  navbar-expand-lg navbar-light bg-light">
    <div class="container-fullwidth">
    <div class="navbar-header ">
        <a class="navbar-brand" href="#">Ling In</a>
        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
    </div>
    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1" >
      <ul class="nav navbar-nav" >    
          <li><a class="link active" href="{% url 'update-status:index' %}">Status <i class="fa fa-star" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'profil:index' %}">Profile <i class="fa fa-user" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'add-friend:index' %}">Friends <i class="fa fa-users" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'home:index' %}">Stats <i class="fa fa-signal" aria-hidden="true"></i></a></li>       
      </ul>
    </div>
  </div>
</nav>


<script src="https://code.jquery.com/jquery-3.2.1.min.js" 
  integrity="sha256-hwg4gsxgFZhOsEEamdOYGBf13FyQuiTwlAQgxVSNgt4=" 
  crossorigin="anonymous"></script> 
<script type="text/javascript" src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

home/templates/home/layout/base.html
{% load staticfiles %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Document</title>
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<link rel="stylesheet" type="text/css" href="bootstrap.css">
<link rel="stylesheet" type="text/css" href="{% static 'profile.css' %}">
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">
</head>
<body>
    <header>
    {% include "home/header.html" %}
    </header>
    <content>
            <div class="">
                {% block content %}
                    <!-- content goes here -->
                {% endblock %}
            </div>
    </content>
    <footer style="text-align: center"><p>&copy; Made with Love</p></footer>
 </body>
</html>

home/templates/home/statistik.html
{% extends "home/layout/base.html" %}

{% block content %}
<style>    
    .photo{
    border-radius: 50% ; 
    width: 220px; 
    height: 220px;
}
.main-title{
    text-align: center;
    color: darkturquoise;
    font-family: "Century Gothic";
    font-weight: bold;
    font-size: 50px;
}
.nama{
    display: inline-flex;
    align-items: center;
    width: 500px; margin-left: 35%;
    color: lightblue;
}
.friends{
    text-align:center;
    color: darkblue;
    font-family: "Century Gothic"
}
.latest{
    width: 500px;
    margin-left: 35%;
}

.update-status-date-added{
    background: lightgray;

}
.update-status-title{
    background: lightgray;
}
.update-status-description{
    background: white;
    height: 100px;
}
</style>

<h1 class="main-title">STATISTICS</h1>
<div class="nama">
<img class="photo" src="https://avatarfiles.alphacoders.com/824/82432.jpg" >
<h2 id="nam">{{name}}</h2>
</div>
<h1 class="friends"><i class="fa fa-users " aria-hidden="true"></i> {{friends}} </h1>
<h1 class="friends"><i class="fa fa-newspaper-o " aria-hidden="true"></i> {{post}}</h1>
<div class="latest">
<h2>Latest Post</h2>
        <div class="media">
            <div class="media-body">
                 <div class="update-status-title">
                    {{name}}
                </div>
                <div class="update-status-date-added">
                  Posted on {{date}}
                </div>
                <div class="update-status-description">
                    {{description}}
                </div>
            </div>
        </div>
</div> 
{% endblock %}  

profil/templates/header.html
<nav class="navbar navbar-default  navbar-expand-lg navbar-light bg-light">
    <div class="container-fullwidth">
    <div class="navbar-header ">
        <a class="navbar-brand" href="#">Ling In</a>
        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
    </div>
    <div class="collapse navbar-collapse"id="bs-example-navbar-collapse-1" >
      <ul class="nav navbar-nav" >    
          <li><a class="link active" href="{% url 'update-status:index' %}">Status <i class="fa fa-star" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'profil:index' %}">Profile <i class="fa fa-user" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'add-friend:index' %}">Friends <i class="fa fa-users" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'home:index' %}">Stats <i class="fa fa-signal" aria-hidden="true"></i></a></li>       
      </ul>
    </div>
  </div>
</nav>

profil/templates/profil.html
{% load staticfiles %}
{% load static %}
<!DOCTYPE html>
<html>
<head>
	<title>Profil</title>
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" crossorigin="anonymous">

	<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">

	<style type="text/css">
		
		.tag{
			width: 100px;
			height: 40px;
		}
		.exp{
			display: inline;
			background-color: white;
			border-style: solid;
			border-width: 1px;
			border-radius: 25%;
			margin-right: 2%;
			padding: 1% 2%;
		}
		table{
			margin : auto auto;
			font-size: 15px;
		}
		body{
			background: lightblue;
		}
	</style>
	<link rel="stylesheet" type="text/css" href="{% static 'css.css' %}">
	<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">
</head>
<body>
	<header>{% include "header.html" %} </header>
	<section id="profil" style="text-align: center">
		<div> <img src="https://avatarfiles.alphacoders.com/824/82432.jpg" align="center" alt="gambar" class="img-circle" width="200px" height="200px"/></div>
		<h4><strong>{{name}}</strong></h4>
		<br>
	</section>
	<table>
		<tbody>
			<tr class="isiProfil">
				<td class="tag">Birthday</td>
				<td class="isiTag">{{Birthday}}</td>
			</tr>
			<tr class="isiProfil">
				<td class="tag">Gender</td>
				<td class="isiTag">{{Gender}}</td>
			</tr>
			<tr class="isiProfil">
				<td class="tag">Expertise</td>
				<td class="isiTag">
					
					{% for x in expertise%}
					<p class="exp">{{x}}</p>
					{% endfor%}	
				
					
				</td>
			</tr>
			<tr class="isiProfil">
				<td class="tag">Description</td>
				<td class="isiTag">{{Description}}</td>
			</tr>
			<tr class="isiProfil">
				<td class="tag">Email</td>
				<td class="isiTag">{{Email}}</td>
			</tr>
		</tbody>
	</table>
		
	<footer style="text-align: center"><p>&copy; Made with Love</p></footer>	
	
	<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.11.0/umd/popper.min.js" integrity="sha384-b/U6ypiBEHpOf/4+1nzFpr53nxSS+GLCkfwBdFNTxtclqqenISfwAzpKaMNFNmj4" crossorigin="anonymous"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js" integrity="sha384-h0AbiXch4ZDo7tp9hKZ4TsHbi047NrKGLO3SEJAg45jXxnGIfYzk4Si90RDIqNm1" crossorigin="anonymous"></script>
</body>
</html>

updatestatus/templates/updatestatus/header.html
<nav class="navbar navbar-default  navbar-expand-lg navbar-light bg-light">
    <div class="container-fullwidth">
    <div class="navbar-header ">
        <a class="navbar-brand" href="#">Ling In</a>
        <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
            <span class="sr-only">Toggle navigation</span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
            <span class="icon-bar"></span>
          </button>
    </div>
    <div class="collapse navbar-collapse"id="bs-example-navbar-collapse-1" >
      <ul class="nav navbar-nav" >    
          <li><a class="link active" href="{% url 'update-status:index' %}">Status <i class="fa fa-star" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'profil:index' %}">Profile <i class="fa fa-user" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'add-friend:index' %}">Friends <i class="fa fa-users" aria-hidden="true"></i></a></li>
          <li><a class="link" href="{% url 'home:index' %}">Stats <i class="fa fa-signal" aria-hidden="true"></i></a></li>       
      </ul>
    </div>
  </div>
</nav>

updatestatus/templates/updatestatus/layout/base.html
{% load staticfiles %}
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="description" content="UPDATE STATUS">
    <meta name="author" content="{{author}}">
    <!-- bootstrap csss -->

    <title>
        {% block title %} UPDATE STATUS {% endblock %}
    </title>
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{% static 'css/tes.css' %}" >
    <link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.4.0/css/font-awesome.min.css">
</head>
<body>
        <header>
                {% include "updatestatus/header.html" %}
        </header>
    <content>
            {% block content %}
           
            {% endblock %}
    </content>
    <footer style="text-align: center"><p>&copy; Made with Love</p></footer>
</body>

</html>

updatestatus/templates/updatestatus/update_status.html
{% extends "updatestatus/layout/base.html" %}
{% block content %}

<hr/>
<section name="input-list" id="input-list">
    <div class="container">
        <form id="form" method="POST" action="{% url 'update-status:add_todo' %}">
            <h2 class="updatestatus">Update Status</h2>
            {% csrf_token %}
            {{ todo_form }}
            <div class="text-right">
                <br><input id="submit" type="submit" class="button" value="Post">
            </div>
              <br><input type="submit" class="button" value="Comment">
            <br>
        </form>
    </div>
</section>
<section name="my-update-status" id="my-update-status">

    <div class="container">
        <h2 class="my-update-status-title">CURCORALNKU</h2>
            {% if todo %}
                {% for data in todo %}
            <div class="row">
                <div class="col-sm-8 col-sm-offset-2">

                        <div class="update-status">
                            <div class="media">
                                <div class="media-left">
                                    <img src="https://avatarfiles.alphacoders.com/824/82432.jpg" style="width: 75px; height: 75px;" class="img-circle">
                                </div>
                                <div class="media-body">
                                    <div class="update-status-delete" data-id="{{data.id}}"><a href="{% url 'update-status:delete_status' id_status=data.id %}">
                                        <span class="glyphicon glyphicon-trash"></span>
                                    </a>
                                    </div>  
                                     <div class="update-status-title">
                                        {{author}}
                                    </div>
                                    <div class="update-status-date-added">
                                        Posted on {{data.created_date}}
                                    </div>
                                    <div class="update-status-description">
                                        {{data.description}}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                {% endfor %}
            {% else %}
            <div class="alert alert-danger text-center">
                <strong>Oops!</strong> Tidak ada data Update Status.
            </div>
            {% endif %}
        </div>
    </div>
</section> 

{% endblock %}